package nc.ui.pubapp.uif2app.actions;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.URI;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumnModel;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.filesystem.IFileSystemService;
import nc.itf.bd.defdoc.IDefdocService;
import nc.itf.th.IThOcrService;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.log.NcLog;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.uif2.editor.BillForm;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
public class MultiSelectDialog extends UIDialog {

	/**
	 * ӷƱƻȡƱ
	 */
	
	private static final long serialVersionUID = 1L;
	private BillForm editor;
	private JTable table;
	/** ȷť */
	private UIButton btnOK;
	private ActionHandler actionHandler = new ActionHandler();
	private UIPanel btnUIPanel;
	private IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private IVOPersistence IVOPersistence = (IVOPersistence) NCLocator.getInstance().lookup(IVOPersistence.class);
	private List<DefdocVO> listDefdocVO = new ArrayList<DefdocVO>();
	private IDefdocService idefservice = NCLocator.getInstance().lookup(IDefdocService.class);
	private String billmaker = InvocationInfoProxy.getInstance().getUserId();
	private String pk_group = InvocationInfoProxy.getInstance().getGroupId();
	private String vdef17 = null;
	private IFileSystemService fileservice = NCLocator.getInstance().lookup(IFileSystemService.class);
	private IThOcrService  ocrservice = (IThOcrService) NCLocator.getInstance().lookup(IThOcrService.class.getName());
	//ȡƱַ
	//private String noauth = "https://dl.mypiaojia.com/api/noauth/?id=";
	private String noauth = "https://api.mypiaojia.com/api/invoiceApi/file/download?id=";
	
	public MultiSelectDialog(BillForm editor) throws Exception {
		this.editor = editor;
		BillCardPanel cpanel=editor.getBillCardPanel();
		vdef17 = (String) cpanel.getHeadItem("vdef17").getValueObject();
		initialize();
		addComponents();
	}

	/**
	 * ʼ
	 */
	private void initialize() {
		setLayout(new BorderLayout());
		this.setBounds(500, 400, 1500, 700);
		this.setResizable(true);
		add(this.getBtnUIPanel(), BorderLayout.SOUTH);
		// Ӽ
		this.addActionListener();
	}
	
	/**
	 * ļ
	 */
	private void addActionListener() {
		this.getBtnOK().addActionListener(this.actionHandler);

	}
	
	
	public UIPanel getBtnUIPanel() {
		if (btnUIPanel == null) {
			btnUIPanel = new nc.ui.pub.beans.UIPanel();
			btnUIPanel.add(this.getBtnOK(), this.getBtnOK().getName());
		}
		return this.btnUIPanel;
	}
	
	private UIButton getBtnOK() {
		if (btnOK == null) {
			btnOK = new UIButton();
			btnOK.setName("btnOK");
			btnOK.setText("ȷ(Y)");
		}
		return this.btnOK;
	}
	@Override
	public String getTitle() {
		// TODO Զɵķ
		return "ӷƱƻȡƱ";
	}
	
	private void addComponents() throws Exception {
	    JPanel panel = new JPanel(new BorderLayout());
	    IThOcrService  ocrservice=(IThOcrService) NCLocator.getInstance().lookup(IThOcrService.class.getName());
	  //ȡtoken
	  	final String token;
	  	JSONObject json = null;
	  	try {
			token = ocrservice.getToken(billmaker);
		} catch (Exception e) {
			throw new Exception("ȡƱtokenʧ:"+e.getMessage());
		} 	
	  	try {
	  		//json = JSONObject.parseObject("{\"data\":{\"infos\":[{\"id\":\"897896873567854592\",\"fid\":\"897896873567854592\",\"code\":\"031002100404\",\"number\":\"25212471\",\"ext\":\"{\\\"ttax\\\":\\\"0.00\\\",\\\"trate\\\":\\\"0\\\",\\\"products\\\":[{\\\"name\\\":\\\"**ͷ\\\",\\\"amount\\\":\\\"855.00\\\",\\\"trate\\\":\\\"0\\\",\\\"tprice\\\":\\\"0\\\",\\\"smodel\\\":\\\"\\\",\\\"muint\\\":\\\"\\\",\\\"qty\\\":\\\"\\\",\\\"price\\\":\\\"\\\",\\\"total\\\":null,\\\"hsprice\\\":null,\\\"txrqq\\\":null,\\\"txrqz\\\":null,\\\"txfCph\\\":null,\\\"txfLx\\\":null,\\\"no\\\":null,\\\"row\\\":null,\\\"taxClassifyCode\\\":\\\"3070401000000000000\\\",\\\"taxClassifyName\\\":null,\\\"specialPolicySign\\\":\\\"1\\\",\\\"realTaxRate\\\":\\\"0\\\",\\\"realTax\\\":\\\"0\\\",\\\"lslbs\\\":null,\\\"zzstsgl\\\":null,\\\"kce\\\":null,\\\"qdbz\\\":null,\\\"cd\\\":null,\\\"nb\\\":null,\\\"enExInfo\\\":null,\\\"standard\\\":null,\\\"remark\\\":null,\\\"sprice\\\":null}],\\\"totalBig\\\":\\\"ưʰԲ\\\",\\\"pcontact\\\":\\\"ϺֶΫ·17213524420435\\\",\\\"pbank\\\":\\\"Ϻũҵйɷ޹˾ؽ֧32406008010037046\\\",\\\"hdlist\\\":false,\\\"content\\\":\\\"**ͷ\\\",\\\"city\\\":\\\"Ϻ\\\",\\\"province\\\":\\\"Ϻ\\\",\\\"reviewer\\\":\\\"ȫ\\\",\\\"receiptor\\\":\\\"֣ѩ\\\",\\\"issuer\\\":\\\"\\\",\\\"ciphertext\\\":\\\"+9/-02+6/<8+8>29*6>53>14/1*,42+/+/9/5<5030/926/24870338,4*</>760366-30978><<*7/1-/2,5/5<508*+/*/7>/*24*8<+44/96\\\",\\\"qrcode\\\":[\\\"01,04,031002100404,25212471,855.00,20230201,47885863301186565170,371,\\\"],\\\"title\\\":\\\"Ϻֵ˰ͨƱ\\\",\\\"corp_seal\\\":\\\"1\\\",\\\"company_seal_mark\\\":\\\"1\\\",\\\"form_type\\\":\\\"ڶ\\\",\\\"form_name\\\":\\\"Ʊ\\\",\\\"service_name\\\":\\\"\\\",\\\"code_confirm\\\":\\\"031002100404\\\",\\\"number_confirm\\\":\\\"25212471\\\",\\\"producer_stamp\\\":\\\"˰ܾ\\\",\\\"stamp_info\\\":\\\"Ϻۼ¥޹˾,9131011077092631XC\\\",\\\"vehicle_mark\\\":\\\"0\\\",\\\"bbank\\\":\\\"\\\",\\\"machine_code\\\":\\\"661610222291\\\",\\\"payee\\\":null,\\\"supplySign\\\":\\\"1\\\",\\\"oil_mark\\\":\\\"N\\\",\\\"bcontact\\\":\\\"\\\",\\\"transit\\\":null,\\\"comment\\\":null}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":298405,\"nid\":253880},\"rid\":\"874812360623947782\",\"holiday\":0,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"1438490101547343873\",\"rb\":{\"trace\":\"\",\"ret\":0,\"lang\":\"53512\"},\"fylx\":\"100005\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"furl\":\"895277218434383874\",\"print\":0,\"attr\":1,\"ctm\":1692257907,\"utm\":1692257907,\"cstm\":1675180800,\"del\":0,\"source\":13,\"uo\":0,\"fname\":\"\\\"ͷ-Ʊ.jpg\",\"jzzt\":0,\"orf\":2,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"\",\"cname\":\"ֵ˰ͨƱ\",\"type\":2,\"date\":\"2023-02-01\",\"chcode\":\"47885863301186565170\",\"valid\":1,\"sreim\":0,\"status\":0,\"iele\":2,\"archiveStatus\":0,\"form_type\":3},\"price\":{\"amount\":\"855.00\",\"total\":\"855.00\",\"treim\":\"\",\"zreim\":\"\",\"dtax\":\"0\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"913101145806174797\",\"company\":\"Ϻ컪׽޹˾\"},\"payer\":{\"tcode\":\"9131011077092631XC\",\"company\":\"Ϻۼ¥޹˾\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0},{\"id\":\"897896847865159682\",\"fid\":\"897896847865159682\",\"code\":\"131002260507\",\"number\":\"50329759\",\"ext\":\"{\\\"ttax\\\":\\\"0.00\\\",\\\"trate\\\":\\\"0\\\",\\\"products\\\":[{\\\"name\\\":\\\"·ѷƱ\\\",\\\"amount\\\":\\\"10.00\\\",\\\"trate\\\":\\\"0.00\\\",\\\"tprice\\\":\\\"0.00\\\",\\\"smodel\\\":null,\\\"muint\\\":null,\\\"qty\\\":\\\"1\\\",\\\"price\\\":\\\"10.00\\\",\\\"total\\\":null,\\\"hsprice\\\":null,\\\"txrqq\\\":null,\\\"txrqz\\\":null,\\\"txfCph\\\":null,\\\"txfLx\\\":null,\\\"no\\\":null,\\\"row\\\":null,\\\"taxClassifyCode\\\":null,\\\"taxClassifyName\\\":null,\\\"specialPolicySign\\\":null,\\\"realTaxRate\\\":null,\\\"realTax\\\":null,\\\"lslbs\\\":null,\\\"zzstsgl\\\":null,\\\"kce\\\":null,\\\"qdbz\\\":null,\\\"cd\\\":null,\\\"nb\\\":null,\\\"enExInfo\\\":null,\\\"standard\\\":null,\\\"remark\\\":null,\\\"sprice\\\":null}],\\\"time\\\":\\\"\\\",\\\"entrance\\\":\\\"Ϻֳվ\\\",\\\"exit\\\":\\\"ƽ\\\",\\\"content\\\":\\\"·ѷƱ\\\",\\\"title\\\":\\\"Ϻٹ·ͨзѷƱ\\\",\\\"highway_flag\\\":\\\"1\\\"}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":298404,\"nid\":253879},\"rid\":\"874800386309513221\",\"holiday\":4,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"1438490101547343873\",\"fylx\":\"100001\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"furl\":\"895277214073094145\",\"print\":0,\"attr\":2,\"ctm\":1692257901,\"utm\":1692257901,\"cstm\":1692257901,\"del\":0,\"source\":13,\"uo\":0,\"fname\":\"\\\"ͨз.jpg\",\"jzzt\":0,\"orf\":2,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"ͨ\",\"cname\":\"·ѷƱ\",\"type\":13,\"date\":\"\",\"valid\":2,\"sreim\":0,\"status\":0,\"iele\":2,\"archiveStatus\":0},\"price\":{\"amount\":\"10.00\",\"total\":\"10.00\",\"treim\":\"\",\"zreim\":\"\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"\",\"company\":\"\"},\"payer\":{\"tcode\":\"\",\"company\":\"\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0},{\"id\":\"897896830844346372\",\"fid\":\"897896830844346372\",\"code\":\"031002200204\",\"number\":\"34421939\",\"ext\":\"{\\\"ttax\\\":\\\"-24056.60\\\",\\\"trate\\\":\\\"6.00\\\",\\\"products\\\":[{\\\"name\\\":\\\"*Ʒ*Ʒ\\\",\\\"amount\\\":\\\"-400943.40\\\",\\\"trate\\\":\\\"6.00\\\",\\\"tprice\\\":\\\"-24056.60\\\",\\\"smodel\\\":\\\"\\\",\\\"muint\\\":\\\"\\\",\\\"qty\\\":\\\"-1\\\",\\\"price\\\":\\\"400943.40\\\",\\\"total\\\":null,\\\"hsprice\\\":null,\\\"txrqq\\\":null,\\\"txrqz\\\":null,\\\"txfCph\\\":null,\\\"txfLx\\\":null,\\\"no\\\":null,\\\"row\\\":null,\\\"taxClassifyCode\\\":\\\"3040301000000000000\\\",\\\"taxClassifyName\\\":null,\\\"specialPolicySign\\\":\\\" \\\",\\\"realTaxRate\\\":\\\" \\\",\\\"realTax\\\":\\\" \\\",\\\"lslbs\\\":null,\\\"zzstsgl\\\":null,\\\"kce\\\":null,\\\"qdbz\\\":null,\\\"cd\\\":null,\\\"nb\\\":null,\\\"enExInfo\\\":null,\\\"standard\\\":null,\\\"remark\\\":null,\\\"sprice\\\":null}],\\\"totalBig\\\":\\\"()ʰǪԲ\\\",\\\"pcontact\\\":\\\"Ϻɽ·180027¥  021-64281588\\\",\\\"pbank\\\":\\\"ͨϺ֧310066179018170265416\\\",\\\"bcontact\\\":\\\"ʡͤر·ͤάҲɾƵ¥\\\",\\\"hdlist\\\":false,\\\"content\\\":\\\"*Ʒ*Ʒ\\\",\\\"comment\\\":\\\"ӦƱ:031002200204:34421931\\\",\\\"city\\\":\\\"Ϻ\\\",\\\"province\\\":\\\"Ϻ\\\",\\\"reviewer\\\":\\\"\\\",\\\"receiptor\\\":\\\"Ʒ\\\",\\\"issuer\\\":\\\"\\\",\\\"ciphertext\\\":\\\"1*227216/2>1-0+5+75+6-70*6+,/9877+>5*+933*+8928970/<48-,>8<27>9966/-3*<*+463+77+6/>,1/++9-+77399<89784***<-></<\\\",\\\"title\\\":\\\"Ϻֵ˰ͨƱ\\\",\\\"corp_seal\\\":\\\"1\\\",\\\"company_seal_mark\\\":\\\"1\\\",\\\"form_type\\\":\\\"һ\\\",\\\"form_name\\\":\\\"\\\",\\\"service_name\\\":\\\"Ʒ\\\",\\\"code_confirm\\\":\\\"031002200204\\\",\\\"number_confirm\\\":\\\"34421939\\\",\\\"producer_stamp\\\":\\\"˰ܾ\\\",\\\"stamp_info\\\":\\\"Ϻ컪޹˾,913101156308648744\\\",\\\"vehicle_mark\\\":\\\"0\\\",\\\"bbank\\\":\\\"\\\",\\\"machine_code\\\":\\\"661710848151\\\",\\\"payee\\\":null,\\\"supplySign\\\":\\\"1\\\",\\\"oil_mark\\\":\\\"N\\\",\\\"transit\\\":null}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":298403,\"nid\":253878},\"rid\":\"876394025452765184\",\"holiday\":0,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"1438490101547343873\",\"rb\":{\"trace\":\"\",\"ret\":0,\"lang\":\"53512\"},\"fylx\":\"0\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"furl\":\"895277141167702016\",\"print\":0,\"attr\":1,\"ctm\":1692257898,\"utm\":1692257898,\"cstm\":1685635200,\"del\":0,\"source\":13,\"uo\":0,\"fname\":\"\\\"Ʊ.jpg\",\"jzzt\":0,\"orf\":2,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"\",\"cname\":\"ֵ˰ͨƱ\",\"type\":2,\"date\":\"2023-06-02\",\"chcode\":\"65426753962695916844\",\"valid\":1,\"sreim\":0,\"status\":0,\"iele\":2,\"archiveStatus\":0,\"form_type\":1},\"price\":{\"amount\":\"-400943.40\",\"total\":\"-425000.00\",\"treim\":\"\",\"zreim\":\"\",\"dtax\":\"0\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"91460000MAC8BPOH3F\",\"company\":\"ͤο޹˾\"},\"payer\":{\"tcode\":\"913101156308648744\",\"company\":\"Ϻ컪޹˾\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0},{\"id\":\"897896813486260226\",\"fid\":\"897896813486260226\",\"code\":\"3100224130\",\"number\":\"08353809\",\"ext\":\"{\\\"ttax\\\":\\\"-15849.06\\\",\\\"trate\\\":\\\"6.00\\\",\\\"products\\\":[{\\\"name\\\":\\\"*Ʒ*Ʒ\\\",\\\"amount\\\":\\\"-264150.94\\\",\\\"trate\\\":\\\"6.00\\\",\\\"tprice\\\":\\\"-15849.06\\\",\\\"smodel\\\":\\\"\\\",\\\"muint\\\":\\\"\\\",\\\"qty\\\":\\\"-1\\\",\\\"price\\\":\\\"264150.94\\\",\\\"total\\\":null,\\\"hsprice\\\":null,\\\"txrqq\\\":null,\\\"txrqz\\\":null,\\\"txfCph\\\":null,\\\"txfLx\\\":null,\\\"no\\\":null,\\\"row\\\":null,\\\"taxClassifyCode\\\":\\\"3040301000000000000\\\",\\\"taxClassifyName\\\":null,\\\"specialPolicySign\\\":null,\\\"realTaxRate\\\":null,\\\"realTax\\\":null,\\\"lslbs\\\":null,\\\"zzstsgl\\\":null,\\\"kce\\\":null,\\\"qdbz\\\":null,\\\"cd\\\":null,\\\"nb\\\":null,\\\"enExInfo\\\":null,\\\"standard\\\":null,\\\"remark\\\":null,\\\"sprice\\\":null}],\\\"totalBig\\\":\\\"()ʰԲ\\\",\\\"pcontact\\\":\\\"Ϻɽ·180027¥  021-64281588\\\",\\\"pbank\\\":\\\"ͨϺ֧310066179018170265416\\\",\\\"bcontact\\\":\\\"ֵ·ڶ 010-68960600\\\",\\\"bbank\\\":\\\"йг֧ 1302068809300206581\\\",\\\"hdlist\\\":false,\\\"content\\\":\\\"*Ʒ*Ʒ\\\",\\\"comment\\\":\\\"ߺֵ˰ר÷ƱϢ3101152306011802\\\",\\\"city\\\":\\\"Ϻ\\\",\\\"province\\\":\\\"Ϻ\\\",\\\"reviewer\\\":\\\"\\\",\\\"receiptor\\\":\\\"Ʒ\\\",\\\"issuer\\\":\\\"\\\",\\\"ciphertext\\\":\\\"08>-812+<5019<>+279+30-3365,02+/7-941/*704/8*29>7+77841,7-+06-4095<70-1*8+3*27-+363,22+5408/32>63846<1>/*<89<15\\\",\\\"title\\\":\\\"Ϻֵ˰ר÷Ʊ\\\",\\\"corp_seal\\\":\\\"1\\\",\\\"company_seal_mark\\\":\\\"1\\\",\\\"form_type\\\":\\\"һ\\\",\\\"form_name\\\":\\\"\\\",\\\"service_name\\\":\\\"Ʒ\\\",\\\"code_confirm\\\":\\\"3100224130\\\",\\\"number_confirm\\\":\\\"08353809\\\",\\\"producer_stamp\\\":\\\"Ϻ\\\",\\\"stamp_info\\\":\\\"Ϻ컪޹˾,913101156308648744\\\",\\\"vehicle_mark\\\":\\\"0\\\",\\\"machine_code\\\":\\\"661710848151\\\",\\\"payee\\\":null,\\\"supplySign\\\":null,\\\"oil_mark\\\":\\\"N\\\",\\\"transit\\\":null}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":298402,\"nid\":253877},\"rid\":\"870831089226219520\",\"holiday\":0,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"1438490101547343873\",\"rb\":{\"trace\":\"\",\"ret\":0,\"lang\":\"53512\"},\"fylx\":\"0\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"furl\":\"894861968057507843\",\"print\":0,\"attr\":1,\"ctm\":1692257893,\"utm\":1692257893,\"cstm\":1685635200,\"del\":0,\"source\":13,\"uo\":0,\"fname\":\"\\\"רƱ.jpg\",\"jzzt\":0,\"orf\":2,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"\",\"cname\":\"ֵ˰ר÷Ʊ\",\"type\":1,\"date\":\"2023-06-02\",\"chcode\":\"83529167511056795531\",\"valid\":1,\"sreim\":0,\"status\":0,\"iele\":2,\"archiveStatus\":0,\"form_type\":1},\"price\":{\"amount\":\"-264150.94\",\"total\":\"-280000.00\",\"treim\":\"\",\"zreim\":\"\",\"dtax\":\"-15849.06\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"91340181MA2MU85K1B\",\"company\":\"ۺͰ()ϲҵ޹˾\"},\"payer\":{\"tcode\":\"913101156308648744\",\"company\":\"Ϻ컪޹˾\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0},{\"id\":\"897896667418607618\",\"fid\":\"897896667418607618\",\"code\":\"1100224130\",\"number\":\"14224356\",\"ext\":\"{\\\"ttax\\\":\\\"128.85\\\",\\\"trate\\\":\\\"13.00\\\",\\\"products\\\":[{\\\"name\\\":\\\"*ʳƷ*Ũȶ\\\",\\\"amount\\\":\\\"991.15\\\",\\\"trate\\\":\\\"13.00\\\",\\\"tprice\\\":\\\"128.85\\\",\\\"smodel\\\":\\\"1000g/\\\",\\\"muint\\\":\\\"\\\",\\\"qty\\\":\\\"10\\\",\\\"price\\\":\\\"99.1150442477876\\\",\\\"total\\\":null,\\\"hsprice\\\":null,\\\"txrqq\\\":null,\\\"txrqz\\\":null,\\\"txfCph\\\":null,\\\"txfLx\\\":null,\\\"no\\\":null,\\\"row\\\":null,\\\"taxClassifyCode\\\":\\\"1030299000000000000\\\",\\\"taxClassifyName\\\":null,\\\"specialPolicySign\\\":null,\\\"realTaxRate\\\":null,\\\"realTax\\\":null,\\\"lslbs\\\":null,\\\"zzstsgl\\\":null,\\\"kce\\\":null,\\\"qdbz\\\":null,\\\"cd\\\":null,\\\"nb\\\":null,\\\"enExInfo\\\":null,\\\"standard\\\":null,\\\"remark\\\":null,\\\"sprice\\\":null}],\\\"totalBig\\\":\\\"ҼǪҼ۷ʰԲ\\\",\\\"pcontact\\\":\\\"г¶·16-1-061010-85322290\\\",\\\"pbank\\\":\\\"йɷ޹˾֧10284000000732695\\\",\\\"bcontact\\\":\\\"Ϻݱ·1188ſƻ20F 64281588\\\",\\\"bbank\\\":\\\"֧ͨ310 066179018170264442\\\",\\\"hdlist\\\":false,\\\"content\\\":\\\"*ʳƷ*Ũȶ\\\",\\\"comment\\\":\\\"2023.05.19컪ƻ20F\\\",\\\"city\\\":\\\"\\\",\\\"province\\\":\\\"\\\",\\\"reviewer\\\":\\\"\\\",\\\"receiptor\\\":\\\"\\\",\\\"issuer\\\":\\\"\\\",\\\"ciphertext\\\":\\\"03409<1<295<86//6+701/863*3/,*//1>/>99-++75+14>0/3-0*66*<,*-3102544-0>8+<99508+>+/8+>*,<60/06+*7901685>03-<>09387/6\\\",\\\"title\\\":\\\"ֵ˰ר÷Ʊ\\\",\\\"corp_seal\\\":\\\"1\\\",\\\"company_seal_mark\\\":\\\"1\\\",\\\"form_type\\\":\\\"\\\",\\\"form_name\\\":\\\"Ʊ\\\",\\\"service_name\\\":\\\"\\\",\\\"machine_code\\\":\\\"499959762588\\\",\\\"code_confirm\\\":\\\"1100224130\\\",\\\"number_confirm\\\":\\\"14224356\\\",\\\"producer_stamp\\\":\\\"\\\",\\\"stamp_info\\\":\\\"˼Ũѯ()޹˾,91110105551350998Q\\\",\\\"vehicle_mark\\\":\\\"0\\\",\\\"payee\\\":null,\\\"supplySign\\\":null,\\\"oil_mark\\\":\\\"N\\\",\\\"transit\\\":null}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":298393,\"nid\":253868},\"oreim\":{\"sreim\":2,\"list_reim\":[{\"dataid\":\"1001ZZ1000000099X06C\",\"date\":1692337222,\"uid\":\"1346\",\"amount\":\"565\",\"cid\":\"1438490101547343873\",\"sreim\":2,\"name\":\"1001ZZ1000000099X06C\",\"number\":\"1001ZZ1000000099X06C\"}]},\"rid\":\"889362545993441292\",\"holiday\":0,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"0\",\"rb\":{\"trace\":\"\",\"ret\":0,\"lang\":\"53512\"},\"fylx\":\"100005\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"furl\":\"889362528899563520\",\"print\":0,\"attr\":1,\"ctm\":1692257859,\"utm\":1692257859,\"cstm\":1685894400,\"del\":0,\"source\":13,\"uo\":0,\"fname\":\"\\\"ȶ1120.png\",\"jzzt\":0,\"orf\":2,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"\",\"cname\":\"ֵ˰ר÷Ʊ\",\"type\":1,\"date\":\"2023-06-05\",\"chcode\":\"12847292283772039095\",\"valid\":1,\"sreim\":0,\"status\":0,\"iele\":2,\"archiveStatus\":0,\"form_type\":3},\"price\":{\"amount\":\"991.15\",\"total\":\"1120.00\",\"treim\":\"565.00\",\"zreim\":\"0.00\",\"dtax\":\"128.85\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"913101140678043533\",\"company\":\"Ϻ컪й滮޹˾\"},\"payer\":{\"tcode\":\"91110105551350998Q\",\"company\":\"˼Ũѯ޹˾\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0},{\"id\":\"897896658978545664\",\"fid\":\"897896658978545664\",\"code\":\"\",\"number\":\"\",\"ext\":\"{\\\"hdlist\\\":false,\\\"title\\\":\\\"Ϻס\\\",\\\"content\\\":\\\"Ϻס\\\",\\\"products\\\":[{\\\"price\\\":\\\"70412.00\\\",\\\"amount\\\":\\\"70412.00\\\",\\\"qty\\\":\\\"1\\\",\\\"name\\\":\\\"Ϻס\\\"}]}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":298392,\"nid\":253867},\"rid\":\"897896658869944328\",\"holiday\":0,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"0\",\"fylx\":\"0\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"pdf\":\"876428479519645696\",\"print\":0,\"attr\":2,\"ctm\":1692257857,\"utm\":1692257857,\"cstm\":1683302400,\"del\":0,\"source\":13,\"uo\":0,\"fname\":\"\\\"202304-컪滮.pdf\",\"jzzt\":0,\"orf\":2,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"\",\"cname\":\"ɱƱ\",\"type\":11,\"date\":\"2023-05-06\",\"valid\":2,\"sreim\":0,\"status\":0,\"iele\":2,\"archiveStatus\":0},\"price\":{\"amount\":\"70412.00\",\"total\":\"70412.00\",\"treim\":\"\",\"zreim\":\"\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"\",\"company\":\"\"},\"payer\":{\"tcode\":\"\",\"company\":\"\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0},{\"id\":\"897896564356169731\",\"fid\":\"897896564356169731\",\"code\":\"\",\"number\":\"23312000000024421173\",\"ext\":\"{\\\"ttax\\\":\\\"446.70\\\",\\\"trate\\\":\\\"6.00\\\",\\\"products\\\":[{\\\"name\\\":\\\"*ʹ*Ʊ\\\",\\\"amount\\\":\\\"7445.30\\\",\\\"trate\\\":\\\"6.00\\\",\\\"tprice\\\":\\\"446.70\\\",\\\"smodel\\\":\\\"\\\",\\\"muint\\\":\\\"\\\",\\\"qty\\\":\\\"\\\",\\\"price\\\":\\\"\\\",\\\"total\\\":null,\\\"hsprice\\\":null,\\\"txrqq\\\":null,\\\"txrqz\\\":null,\\\"txfCph\\\":null,\\\"txfLx\\\":null,\\\"no\\\":null,\\\"row\\\":null,\\\"taxClassifyCode\\\":\\\"3040802000000000000\\\",\\\"taxClassifyName\\\":null,\\\"specialPolicySign\\\":null,\\\"realTaxRate\\\":null,\\\"realTax\\\":null,\\\"lslbs\\\":null,\\\"zzstsgl\\\":null,\\\"kce\\\":null,\\\"qdbz\\\":null,\\\"cd\\\":null,\\\"nb\\\":null,\\\"enExInfo\\\":null,\\\"standard\\\":null,\\\"remark\\\":null,\\\"sprice\\\":null}],\\\"totalBig\\\":\\\"Ǫư۾ʰԲ\\\",\\\"hdlist\\\":false,\\\"content\\\":\\\"*ʹ*Ʊ\\\",\\\"city\\\":\\\"Ϻ\\\",\\\"province\\\":\\\"Ϻ\\\",\\\"reviewer\\\":\\\"\\\",\\\"receiptor\\\":\\\"\\\",\\\"issuer\\\":\\\"ܫh\\\",\\\"title\\\":\\\"ӷƱ(ͨƱ)\\\",\\\"corp_seal\\\":\\\"0\\\",\\\"company_seal_mark\\\":\\\"0\\\",\\\"form_type\\\":\\\"\\\",\\\"service_name\\\":\\\"ʹ\\\",\\\"code_confirm\\\":\\\"\\\",\\\"producer_stamp\\\":\\\"˰ܾ\\\",\\\"vehicle_mark\\\":\\\"0\\\",\\\"pcontact\\\":\\\"Ϻɽ·1602źʹ㳡B12¥ 200235\\\",\\\"bbank\\\":\\\"ͨйɷ޹˾Ϻɽ·֧ 310066218018800077148\\\",\\\"machine_code\\\":null,\\\"payee\\\":null,\\\"supplySign\\\":null,\\\"oil_mark\\\":\\\"N\\\",\\\"bcontact\\\":\\\"Ϻݱ·118811¥ 64281588\\\",\\\"pbank\\\":\\\"Ϻɽ·֧ 1001298019005580481\\\",\\\"transit\\\":null,\\\"comment\\\":null}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":298391,\"nid\":253866},\"rid\":\"889367240487723015\",\"holiday\":0,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"1438490101547343873\",\"rb\":{\"trace\":\"\",\"ret\":0,\"lang\":\"53512\"},\"fylx\":\"0\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"pdf\":\"889367214624997377\",\"print\":0,\"attr\":1,\"ctm\":1692257835,\"utm\":1692257835,\"cstm\":1685980800,\"del\":0,\"source\":13,\"uo\":0,\"fname\":\"\\\"000151 Ʊ7892.pdf\",\"jzzt\":0,\"orf\":1,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"\",\"cname\":\"ӷƱͨƱ\",\"type\":33,\"date\":\"2023-06-06\",\"chcode\":\"23312000000024421173\",\"valid\":1,\"sreim\":0,\"status\":0,\"iele\":1,\"archiveStatus\":0},\"price\":{\"amount\":\"7445.30\",\"total\":\"7892.00\",\"treim\":\"\",\"zreim\":\"\",\"dtax\":\"0\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"91310000MA1JN0H0X8\",\"company\":\"Ϻ޹˾\"},\"payer\":{\"tcode\":\"913101046727491455\",\"company\":\"Ϻ˳Уţ޹˾\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0},{\"id\":\"895310852297187335\",\"fid\":\"895310852297187335\",\"code\":\"3100222130\",\"number\":\"52170412\",\"ext\":\"{\\\"ttax\\\":\\\"-8834.86\\\",\\\"trate\\\":\\\"9.00\\\",\\\"products\\\":[{\\\"name\\\":\\\"*Ӫ*ͣλ\\\",\\\"amount\\\":\\\"-98165.14\\\",\\\"trate\\\":\\\"9.00\\\",\\\"tprice\\\":\\\"-8834.86\\\",\\\"smodel\\\":\\\"\\\",\\\"muint\\\":\\\"\\\",\\\"qty\\\":\\\"-1\\\",\\\"price\\\":\\\"98165.137614678899083\\\",\\\"total\\\":null,\\\"hsprice\\\":null,\\\"txrqq\\\":null,\\\"txrqz\\\":null,\\\"txfCph\\\":null,\\\"txfLx\\\":null,\\\"no\\\":null,\\\"row\\\":null,\\\"taxClassifyCode\\\":\\\"3040502000000000000\\\",\\\"taxClassifyName\\\":null,\\\"specialPolicySign\\\":null,\\\"realTaxRate\\\":null,\\\"realTax\\\":null,\\\"lslbs\\\":null,\\\"zzstsgl\\\":null,\\\"kce\\\":null,\\\"qdbz\\\":null,\\\"cd\\\":null,\\\"nb\\\":null,\\\"enExInfo\\\":null,\\\"standard\\\":null,\\\"remark\\\":null,\\\"sprice\\\":null}],\\\"totalBig\\\":\\\"()ҼʰǪԲ\\\",\\\"pcontact\\\":\\\"Ϻ·928110260919800\\\",\\\"pbank\\\":\\\"ũϺ·֧03-439200040002951\\\",\\\"bcontact\\\":\\\"Ϻ·928Űʹ㳡3¥ 021-64281588\\\",\\\"hdlist\\\":false,\\\"content\\\":\\\"*Ӫ*ͣλ\\\",\\\"comment\\\":\\\"ַƱϢ3101142211224666\\\",\\\"city\\\":\\\"Ϻ\\\",\\\"province\\\":\\\"Ϻ\\\",\\\"reviewer\\\":\\\"Ԭ÷\\\",\\\"receiptor\\\":\\\"Ԭ÷\\\",\\\"issuer\\\":\\\"Ԭ÷\\\",\\\"ciphertext\\\":\\\"03859706**50>/*3435951+7>3-5,3<+1368--99040<958-383<+*14*,--*93167686>/*>99*><>>72650<,<9>4+6817911/>25031<+*<-7>58\\\",\\\"title\\\":\\\"Ϻֵ˰ר÷Ʊ\\\",\\\"corp_seal\\\":\\\"1\\\",\\\"company_seal_mark\\\":\\\"1\\\",\\\"form_type\\\":\\\"ڶ\\\",\\\"form_name\\\":\\\"ֿ\\\",\\\"service_name\\\":\\\"Ӫ\\\",\\\"code_confirm\\\":\\\"100222130\\\",\\\"number_confirm\\\":\\\"52170412\\\",\\\"producer_stamp\\\":\\\"Ϻ\\\",\\\"stamp_info\\\":\\\"Ϻҵ޹˾,91310104552987106A\\\",\\\"vehicle_mark\\\":\\\"0\\\",\\\"bbank\\\":\\\"\\\",\\\"machine_code\\\":\\\"589908987436\\\",\\\"payee\\\":null,\\\"supplySign\\\":null,\\\"oil_mark\\\":\\\"N\\\",\\\"transit\\\":null}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":293107,\"nid\":249576,\"doc_id\":\"306581\",\"img_id\":\"308499\"},\"rid\":\"895310852411482119\",\"holiday\":0,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"1438490101547343873\",\"rb\":{\"trace\":\"\",\"ret\":0,\"lang\":\"53512\"},\"fylx\":\"0\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"furl\":\"895310843843182593\",\"print\":0,\"attr\":1,\"ctm\":1691655802,\"utm\":1691655802,\"cstm\":1670428800,\"del\":0,\"source\":5,\"uo\":0,\"fname\":\"inc-20230810162319-28152.jpg\",\"jzzt\":0,\"orf\":2,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"\",\"cname\":\"ֵ˰ר÷Ʊ\",\"type\":1,\"date\":\"2022-12-08\",\"chcode\":\"00673689945865883044\",\"valid\":1,\"sreim\":0,\"status\":0,\"iele\":2,\"archiveStatus\":0,\"form_type\":2},\"price\":{\"amount\":\"-98165.14\",\"total\":\"-107000.00\",\"treim\":\"\",\"zreim\":\"\",\"dtax\":\"-8834.86\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"913101140678043533\",\"company\":\"Ϻ컪й滮޹˾\"},\"payer\":{\"tcode\":\"91310104552987106A\",\"company\":\"Ϻҵ޹˾\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0},{\"id\":\"895293182809153541\",\"fid\":\"895293182809153541\",\"code\":\"4403223130\",\"number\":\"16222560\",\"ext\":\"{\\\"ttax\\\":\\\"1485.15\\\",\\\"trate\\\":\\\"1.00\\\",\\\"products\\\":[{\\\"name\\\":\\\"*רҵ*Ʒ\\\",\\\"amount\\\":\\\"148514.85\\\",\\\"trate\\\":\\\"1.00\\\",\\\"tprice\\\":\\\"1485.15\\\",\\\"smodel\\\":\\\"\\\",\\\"muint\\\":\\\"\\\",\\\"qty\\\":\\\"\\\",\\\"price\\\":\\\"\\\",\\\"total\\\":null,\\\"hsprice\\\":null,\\\"txrqq\\\":null,\\\"txrqz\\\":null,\\\"txfCph\\\":null,\\\"txfLx\\\":null,\\\"no\\\":null,\\\"row\\\":null,\\\"taxClassifyCode\\\":\\\"3040104030000000000\\\",\\\"taxClassifyName\\\":null,\\\"specialPolicySign\\\":null,\\\"realTaxRate\\\":null,\\\"realTax\\\":null,\\\"lslbs\\\":null,\\\"zzstsgl\\\":null,\\\"kce\\\":null,\\\"qdbz\\\":null,\\\"cd\\\":null,\\\"nb\\\":null,\\\"enExInfo\\\":null,\\\"standard\\\":null,\\\"remark\\\":null,\\\"sprice\\\":null}],\\\"totalBig\\\":\\\"ҼʰԲ\\\",\\\"pcontact\\\":\\\"ǰۺǰһ·1A201ңפǰ޹˾ 18926756491\\\",\\\"pbank\\\":\\\"344036230300770915\\\",\\\"bcontact\\\":\\\"Ϻݱ·11881101 34768388\\\",\\\"bbank\\\":\\\"ͨɽ·֧ 310066218018800042174\\\",\\\"hdlist\\\":false,\\\"content\\\":\\\"*רҵ*Ʒ\\\",\\\"comment\\\":\\\"Ϻ1Ŀ滮ѯʷҵ˰:91440300MA5G7D629X ҵ:˼ýڣ޹˾\\\",\\\"city\\\":\\\"\\\",\\\"province\\\":\\\"㶫ʡ\\\",\\\"reviewer\\\":\\\"\\\",\\\"receiptor\\\":\\\"\\\",\\\"issuer\\\":\\\"DK03\\\",\\\"ciphertext\\\":\\\"532-597>-39+*>615+2+-3<85/7,>8/>/53910<*9<275<4<>691--5,1-4658931>7--2968*615+27-6<,85*6<7>>/*583321*+27*6/8658\\\",\\\"title\\\":\\\"ֵ˰ר÷Ʊ\\\",\\\"corp_seal\\\":\\\"1\\\",\\\"company_seal_mark\\\":\\\"1\\\",\\\"form_type\\\":\\\"ڶ\\\",\\\"form_name\\\":\\\"ֿ\\\",\\\"agent_mark\\\":\\\"1\\\",\\\"service_name\\\":\\\"רҵ\\\",\\\"code_confirm\\\":\\\"4403223130\\\",\\\"number_confirm\\\":\\\"16222560\\\",\\\"producer_stamp\\\":\\\"\\\",\\\"stamp_info\\\":\\\"˼޹˾ݷֹ˾,91440300MA5G7D629X\\\",\\\"vehicle_mark\\\":\\\"0\\\",\\\"machine_code\\\":\\\"661621649484\\\",\\\"payee\\\":null,\\\"supplySign\\\":null,\\\"oil_mark\\\":\\\"N\\\",\\\"transit\\\":null}\",\"user\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"oa\":{\"id\":293007,\"nid\":249472,\"doc_id\":\"306468\",\"img_id\":\"308386\"},\"rid\":\"895293182822563849\",\"holiday\":0,\"ic\":0,\"suser\":{\"cid\":\"1438490101547343873\",\"name\":\"\",\"uid\":\"1346\",\"appid\":\"1438490100786012161\"},\"rcid\":\"1438490101547343873\",\"rb\":{\"trace\":\"\",\"ret\":0,\"lang\":\"53512\"},\"fylx\":\"0\",\"total\":0,\"origin\":{\"id\":\"\",\"fid\":\"\"},\"modify_info\":{\"furl\":\"895293178650296320\",\"print\":0,\"attr\":1,\"ctm\":1691651688,\"utm\":1691651688,\"cstm\":1679587200,\"del\":0,\"source\":5,\"uo\":0,\"fname\":\"inc-20230810151446-35193.jpg\",\"jzzt\":0,\"orf\":2,\"is_share\":0},\"comm_info\":{\"pro\":{\"kind\":\"\",\"cname\":\"ֵ˰ר÷Ʊ\",\"type\":1,\"date\":\"2023-03-24\",\"chcode\":\"74155452151460432592\",\"valid\":1,\"sreim\":0,\"status\":0,\"iele\":2,\"archiveStatus\":0,\"form_type\":2},\"price\":{\"amount\":\"148514.85\",\"total\":\"150000.00\",\"treim\":\"\",\"zreim\":\"\",\"dtax\":\"1485.15\",\"hasTalliedMoney\":\"0\"},\"buyer\":{\"tcode\":\"91310000MA1FL3K296\",\"company\":\"װϣϺ޹˾\"},\"payer\":{\"tcode\":\"44033100DK00141\",\"company\":\"˰ܾ˰ִ˰03\"}},\"lian_id\":\"0\",\"origin_fid\":\"0\",\"bill_type\":0}],\"total\":9,\"end_flag\":0},\"actionMsg\":{\"code\":0,\"message\":\"ִгɹ\"}}");
			json = ocrservice.SelectORCInvoice(token);
	  } catch (Exception e) {
		  	
			throw new Exception("ȡƱƷƱ:"+e.getMessage());
		}
	    try {
	    	JSONObject data = json.getJSONObject("data");
			JSONArray infos = data.getJSONArray("infos");
			//ƱвڷƱ
			if(infos != null) {
				List<Object[]> dataList = new ArrayList<Object[]>();
				for(int j = 0;j < infos.size();j++){
					JSONObject info = infos.getJSONObject(j);
					String memo = info.getString("number");//Ʊ
					String code = info.getString("fid");
					String fid = info.getString("fid");
					String codenumber = info.getString("code"); //Ʊ
					//ⷢƱƱźͷƱ벻
					if(codenumber == null || "".equals(codenumber)) {
						codenumber = "0";
					}
					if(memo == null || "".equals(memo)) {
						memo = "0";
					}
					String ext = info.getString("ext");
					JSONObject extobj = JSONObject.parseObject(ext);
					String trate = extobj.getString("trate");//˰
					JSONObject modify_info = info.getJSONObject("modify_info");
					String name = modify_info.getString("fname");
					JSONObject comm_info = info.getJSONObject("comm_info");
					JSONObject pro = comm_info.getJSONObject("pro");
					String furl = modify_info.getString("furl");//ƱͼƬid 
					if (furl == null) {
					    String pdf = modify_info.getString("pdf");
					    String pi = pro.getString("pi");
					    furl = pdf != null ? pdf : pi;
					}
					String date = pro.getString("date");//Ʊ
					String type = pro.getString("type");//Ʊ
					String cname = pro.getString("cname");//Ʊ
					//String kind = pro.getString("kind");//Ʊ
					String kind = extobj.getString("content");
					JSONObject price = comm_info.getJSONObject("price");
					String amount = "0";
					String total = price.getString("total");//˰ϼ
					//ûм˰ϼƱʾݲǷƱֱ
					if(total == null || "".equals(total) || total == "0") {
						continue;
					}
					String dtax = price.getString("dtax") == null ? "0" : price.getString("dtax");//ɵֿ˰
					String ttax = "0";
					//пɵֿ˰˰˰˰ڿɵֿ˰˰ʵ˰
					//ûпɵֿ˰˰˰+˰˰0˰ʵ0
					if("0".equals(dtax)) {
						//˰+˰ = ˰ϼ
						amount = total;
						ttax = "0";//˰
						trate = "0";//˰
					}else {
						amount = price.getString("amount");//˰
						ttax = extobj.getString("ttax");//˰
					}
					JSONObject buyer = comm_info.getJSONObject("buyer");
					String mnecode = buyer.getString("tcode");//˰ʶ
					String name2 = buyer.getString("company");//򷽹˾
					JSONObject payer = comm_info.getJSONObject("payer");
					String name3 = payer.getString("tcode");//۷˰ʶ
					String name4 = payer.getString("company");//򷽹˾
					Map<Object,Object> mappo =  QryNorigtaxmny(code);
					UFDouble norigtaxmny =  new UFDouble(mappo.get("norigtaxmny") == null ? 0.00 : Double.valueOf(mappo.get("norigtaxmny").toString()),2);//ʹü˰ϼ
					UFDouble norigmny = new UFDouble(mappo.get("norigmny") == null ? 0.00 : Double.valueOf(mappo.get("norigmny").toString()),2);//ʹ˰
					UFDouble ntax = new UFDouble(mappo.get("ntax") == null ? 0.00 : Double.valueOf(mappo.get("ntax").toString()),2);//ʹ˰
					
					UFDouble norigtaxmnys = new UFDouble(total ==  null ? 0.00 : Double.parseDouble(total),2);//Ʊ˰ϼ
					UFDouble norigmnys = new UFDouble(amount ==  null ? 0.00 : Double.parseDouble(amount),2);//Ʊ˰
					UFDouble ntaxs = new UFDouble(ttax ==  null ? 0.00 : Double.parseDouble(ttax),2);//Ʊ˰
					DefdocVO defvo = new DefdocVO();
					long l = System.currentTimeMillis();
					//ƱظȡԶ嵵汣棬ʱ֤Ψһ
					code += ""+l;
					memo += ""+l;
					defvo.setAttributeValue("code",code);
					defvo.setAttributeValue("name",memo);
					defvo.setAttributeValue("memo", name );
					defvo.setAttributeValue("mnecode", mnecode);
					defvo.setAttributeValue("name2", name2);
					defvo.setAttributeValue("name3", name3);
					defvo.setAttributeValue("name4", name4);
					defvo.setAttributeValue("name5", fid);
					defvo.setAttributeValue("name6", vdef17);
					defvo.setAttributeValue("pk_defdoclist", QryOCRPk());
					defvo.setAttributeValue("pk_group", pk_group);
					defvo.setAttributeValue("pk_org", pk_group);
					defvo.setAttributeValue("datatype", 1);
					defvo.setAttributeValue("enablestate", 2);
					defvo.setAttributeValue("shortname", amount);
					defvo.setAttributeValue("shortname2", total);
					defvo.setAttributeValue("shortname3", ttax);
					defvo.setAttributeValue("pid", date);
					defvo.setAttributeValue("shortname5", cname);
					defvo.setAttributeValue("shortname6", trate);
					defvo.setAttributeValue("dataoriginflag", 1);//0ϴ 1Ʊƻȡ
					defvo.setAttributeValue("shortname4", kind);
					defvo.setAttributeValue("innercode", codenumber);
					defvo.setAttributeValue("modifier", dtax);
					listDefdocVO.add(defvo);
					Boolean blen = QryOCRNumber(code, "1")  == null ? false : true;
					String url = noauth+furl;
					String link = "<html><a href="+url+">"+name+"</a></html>";
					Object[] obj = {blen,cname,norigtaxmnys.sub(norigtaxmny),norigmnys.sub(norigmny),ntaxs.sub(ntax),total,amount,trate
							,ttax,dtax,codenumber,memo,link,mnecode,name2,name3,name4,kind,date,code};
					dataList.add(obj);
				}
				String[] columnNames = {"ȫѡ","Ʊ" ,"ú˰","˰","˰","Ʊ溬˰","Ʊ˰","Ʊ˰","Ʊ˰"
						,"Ʊɵֿ۽","Ʊ","Ʊ","Ʊ","˰ʶ","򷽹˾","۷˰ʶ","۷˾"
						,"Ʊ","Ʊʱ","fid"};
				Object[][] dataArray = new Object[dataList.size()][columnNames.length];
				for (int i = 0; i < dataList.size(); i++) {
		            Object[] rowData = dataList.get(i);
		            dataArray[i] = rowData;
		        }
				DefaultTableModel model = new DefaultTableModel(dataArray, columnNames) {
			        @Override
			        public boolean isCellEditable(int row, int column) {
			            return (column == 0); // ֻһпɱ༭
			        }
			    };

			    table = new JTable(model);
			    table.getColumnModel().getColumn(0).setPreferredWidth(50);
			    table.getColumnModel().getColumn(0).setMaxWidth(50);
			    table.getColumnModel().getColumn(0).setCellRenderer(new CheckBoxRenderer());
			    table.getColumnModel().getColumn(0).setCellEditor(new CheckBoxEditor());
			    // ϶
			    table.getTableHeader().setReorderingAllowed(false);

			    TableColumnModel columnModel = table.getColumnModel();
			    // УÿΪ150
		        for (int i = 0; i < columnModel.getColumnCount(); i++) {
		        	if(i >= 10 || i == 1) {
		        		table.getColumnModel().getColumn(i).setPreferredWidth(150);
		        	}
		        }

			    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			    // ¼
			    table.addMouseListener(new MouseAdapter() {
			        public void mouseClicked(MouseEvent e) {
			            int row = table.rowAtPoint(e.getPoint());
			            int column = table.columnAtPoint(e.getPoint());
			           
			            // 
			            if (column == 12) {
			                String htmlLink = ((String) table.getValueAt(row, column)).replaceAll(".*<a href=(.*?)>.*", "$1");
			                // ʹDesktopĬ
			                try {
			                    Desktop.getDesktop().browse(new URI(htmlLink+"&token="+token));
			                } catch (Exception ex) {
			                    ex.printStackTrace();
			                }
			            }
			        }
			    });

			    table.setRowSelectionAllowed(false);
			    JScrollPane scrollPane = new JScrollPane(table);
			    scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			    panel.add(scrollPane, BorderLayout.CENTER);


			    panel.add(scrollPane, BorderLayout.CENTER);

			    getContentPane().add(panel);

		        // ñеĸѡ¼
		        addSelectAllMouseListener();
			}else {
				throw new Exception("ǰûƱ޷Ʊ");
			}
		} catch (Exception e) {
			throw new Exception(e.getMessage());
		}
	    
	}
	boolean isSelectAll = false;
	private void addSelectAllMouseListener() {
	    JTableHeader header = table.getTableHeader();
	    header.addMouseListener(new MouseAdapter() {
	        @Override
	        public void mouseClicked(MouseEvent e) {
	            int column = table.columnAtPoint(e.getPoint());
	            if (column == 0) {
	                boolean isAllSelected = true;
	                
	                // жǷδѡ
	                for (int i = 0; i < table.getRowCount(); i++) {
	                	boolean isSelected = ((Boolean) table.getValueAt(i, column)).booleanValue();
	                    if (!isSelected) {
	                        isAllSelected = false;
	                        break;
	                    }
	                }
	                
	                // δѡȫѡ
	                if (!isAllSelected) {
	                    for (int i = 0; i < table.getRowCount(); i++) {
	                        table.setValueAt(true, i, column);
	                    }
	                }
	                
	                // ȫȡѡ
	                else {
	                    for (int i = 0; i < table.getRowCount(); i++) {
	                        table.setValueAt(false, i, column);
	                    }
	                }
	            }
	            
	            // ĲȫѡУֱȡȫѡ״̬
	            else {
	                if (isSelectAll) {
	                    isSelectAll = false;
	                    table.setValueAt(false, 0, 0);
	                }
	            }
	        }
	    });
	}

	private static class CheckBoxRenderer extends DefaultTableCellRenderer {
	    private final JCheckBox checkBox;

	    public CheckBoxRenderer() {
	        checkBox = new JCheckBox();
	        checkBox.setHorizontalAlignment(JCheckBox.CENTER);
	    }

	    @Override
	    public Component getTableCellRendererComponent(JTable table, Object value,
	                                                   boolean isSelected, boolean hasFocus,
	                                                   int row, int column) {
	        if (value instanceof Boolean) {
	            checkBox.setSelected((Boolean) value);
	        }
	        
	        // øѡԱѡ
	        checkBox.setEnabled(true);
	        
	        return checkBox;
	    }
	}
	
	private class CheckBoxEditor extends DefaultCellEditor {
	    private JCheckBox checkBox;

	    public CheckBoxEditor() {
	        super(new JCheckBox());
	        checkBox = (JCheckBox) getComponent();
	        checkBox.setHorizontalAlignment(JCheckBox.CENTER);
	    }

	    @Override
	    public Object getCellEditorValue() {
	        return checkBox.isSelected();
	    }
	}
	
	class ActionHandler implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == MultiSelectDialog.this.getBtnOK()) {
				// ȷťִ¼
				MultiSelectDialog.this.doOKAction();
			}
			
		}
	}
	
	private void doOKAction(){
		try {
			chend();
			List<Object[]> list  = getSelectedData();
			for (int i = 0; i < list.size(); i++) {
				//ѡеcode
				String code = list.get(i)[19].toString();
				for (int j = 0; j < listDefdocVO.size(); j++) {
					//ȡcode
					String codes = listDefdocVO.get(j).getCode();
					//ƥѡֵԶ嵵
					if(code.equals(codes)) {
						DefdocVO  defdoc = QryOCRNumber(code,null);
						if(defdoc == null) {
							//
							DefdocVO defdocVO = listDefdocVO.get(j);
							idefservice.insertDefdocs(pk_group,new DefdocVO[] { defdocVO });
							Map<String,String> map = new HashMap<String,String>();
							map.put("KYHSJE", list.get(i)[2].toString());
							map.put("KYWSJE", list.get(i)[3].toString());
							map.put("JYSE", list.get(i)[4].toString());
							String htmlLink =  list.get(i)[12].toString().replaceAll(".*<a href=(.*?)>.*", "$1");
							map.put("FPXZ", htmlLink);
							map.put("NUMBERID", list.get(i)[19].toString());
							map.put("VDEF17",vdef17);
							ocrservice.addORC(map);
							break;
						}					
					}
				}
				
			}
			this.dispose();
		} catch (Exception e) {
			MessageDialog.showErrorDlg(null, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,e.getMessage());
		}
		
	}
	
	private void chend() throws Exception {
		//ƱδѡƱ
		List<Object[]> unlist = getUnselectedData();
		int count =editor.getBillCardPanel().getBodyPanel().getTable().getRowCount();//ϸ
		//ȡѾѡķƱ
		List<String> lisvdef20 = new ArrayList<String>();
		for(int i = 0;i<count;i++){
			Object objvbdef20 = editor.getBillCardPanel().getBodyValueAt(i, "vbdef20");//
			if(null != objvbdef20){
				String vbdef20 = objvbdef20.toString();
				String[] vbd20arry = vbdef20.split(",");
				for(int j = 0;j < vbd20arry.length;j++){
					lisvdef20.add(vbd20arry[j]);
				}
			}
		 }
		
//		List<String> memoarry = QryDefMemo(lisvdef20);
//		String number = "";//Ʊ
//		for (int i = 0; i < unlist.size(); i++) {
//			//Ʊûѡݣֱɾ
//			if(memoarry.size() == 0) {
//				String code = unlist.get(i)[19].toString();
//				number += code.substring(0, code.indexOf("")) +",";
//			}
//			//δѡеķƱ
//			String name = unlist.get(i)[12].toString().replaceAll("<[^>]*>", "");
//			for (int j = 0; j < memoarry.size(); j++) {
//				//ѡеķƱ
//				String names = memoarry.get(j);
//				if(name.equals(names)) {
//					throw new Exception(name+":ƱѾѡȡѡ");
//				}
//				//Ʊѡݣƥûͬɾ
//				if((j+1) == memoarry.size()) {
//					String code = unlist.get(i)[19].toString();
//					number += code.substring(0, code.indexOf("")) +",";
//				}
//			}
//		}
		List<String> memoarry = QryDefMemo(lisvdef20);
		String number = "";//Ʊ
		for (int i = 0; i < unlist.size(); i++) {
			//Ʊûѡݣֱɾ
			if(memoarry.size() == 0) {
				String code = unlist.get(i)[19].toString();
				number += code.substring(0, code.indexOf("")) +",";
			}
			//δѡеcode
			String code = unlist.get(i)[19].toString();
			for (int j = 0; j < memoarry.size(); j++) {
				
				//ѡеķƱ
				String codes = memoarry.get(j);
				//Ʊ
				String name = unlist.get(i)[12].toString().replaceAll("<[^>]*>", "");
				if(code.substring(0, code.indexOf("")).equals(codes.substring(0, codes.indexOf("")))) {
					throw new Exception(name+":ƱѾѡȡѡ");
				}
				//Ʊѡݣƥûͬɾ
				if((j+1) == memoarry.size()) {
					number += code.substring(0, code.indexOf("")) +",";
				}
			}
		}
		if(!"".equals(number)) {
			DeleteDOC(number);
			ocrservice.deleteORC(number, vdef17,1);
		}
		
	}
	
	
    //vdef17+"/"+defdocVO.getMemo()
    private void DeleteFile(String pjnames) throws Exception {
    	String[] names = pjnames.split(",");
		for(int i=0;i<names.length;i++){
			names[i]=vdef17+"/"+names[i];
		}

    	fileservice.deleteNCFileNodes(names);
				
    	
    }
	
	//ȡѡе
	private List<Object[]> getSelectedData() {
	    List<Object[]> selectedData = new ArrayList<Object[]>();

	    for (int i = 0; i < table.getRowCount(); i++) {
	        boolean isSelected = (Boolean) table.getValueAt(i, 0);
	        if (isSelected) {
	            Object[] rowData = new Object[table.getColumnCount()];
	            for (int j = 0; j < table.getColumnCount(); j++) {
	                rowData[j] = table.getValueAt(i, j);
	            }
	            selectedData.add(rowData);
	        }
	    }

	    return selectedData;
	}
	
	//ȡûѡе
	private List<Object[]> getUnselectedData() {
	    List<Object[]> unselectedData = new ArrayList<Object[]>();

	    for (int i = 0; i < table.getRowCount(); i++) {
	        boolean isSelected = (Boolean) table.getValueAt(i, 0);
	        if (!isSelected) { // ޸жΪ !isSelected
	            Object[] rowData = new Object[table.getColumnCount()];
	            for (int j = 0; j < table.getColumnCount(); j++) {
	                rowData[j] = table.getValueAt(i, j);
	            }
	            unselectedData.add(rowData);
	        }
	    }

	    return unselectedData;
	}

	
    //ѯԶ嵵pk
    private String QryOCRPk() throws Exception{
    	String sql = "select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0";
    	Object object = null;
			object = iuap.executeQuery(sql, new ColumnProcessor());
		if (object==null) {
			return null;
		}else {
			return object.toString();
		}
    }
	
    //ѯƱǷԶѴ
    private DefdocVO QryOCRNumber(String number,String dataoriginflag) throws Exception{
    	//ȥƴʱ
    	String code = number.substring(0, number.indexOf(""));
    	StringBuffer sql = new StringBuffer();
    	sql.append("SELECT");
    	sql.append(" name6, ");
    	sql.append(" dataoriginflag ");
    	sql.append(" FROM");
    	sql.append(" bd_defdoc");
    	sql.append(" WHERE");
    	sql.append("  code like '"+code+"%'");
    	sql.append(" AND name6 = '"+vdef17+"'");
    	if(dataoriginflag != null) {
    		sql.append(" AND dataoriginflag = '"+dataoriginflag+"'");
    	}
    	
    	sql.append(" AND nvl( dr, 0 ) = 0");
		return (DefdocVO) iuap.executeQuery(sql.toString(), new BeanProcessor(DefdocVO.class));
    }
    

    //ҪķƱʱɾ
    private void DeleteDOC(String number) throws Exception {
    	String[] arrNumber = number.split(",");
    	SqlBuilder sql = new  SqlBuilder();
    	sql.append(" name6 = '"+vdef17+"'");
    	if(arrNumber.length == 1) {
    		sql.append(" AND SUBSTR(code, 1, INSTR(code, '')-1) = '"+arrNumber[0].toString()+"'");
    	}else {
    		SqlBuilder sqlb = new SqlBuilder();
			sqlb.append("SUBSTR(code, 1, INSTR(code, '')-1)", arrNumber);
    		sql.append(" AND  "+sqlb.toString());
    	}
    	
    	sql.append(" AND dataoriginflag = '1'");
    	sql.append(" AND pk_defdoclist = ( SELECT pk_defdoclist FROM bd_defdoclist WHERE code = 'OCRTHNC' AND nvl( dr, 0 ) = 0 )");
    	IVOPersistence.deleteByClause(DefdocVO.class, sql.toString());
    }
    
	private List<String> QryDefMemo(List<String> lisvdef20) throws Exception{
		 String[] arraydef20 = lisvdef20.toArray(new String[0]);
		 List<String> arrayvos = new ArrayList<String>();
		 if(null == arraydef20 || arraydef20.length == 0){
			 return arrayvos; 
		 }
		 
		 SqlBuilder	sqlb = new SqlBuilder();
		 sqlb.append("select code  ");
		 sqlb.append("from  bd_defdoc ");
		 sqlb.append("where nvl(dr, 0) = 0 and pk_defdoclist= ");
		 sqlb.append("(select pk_defdoclist ");
		 sqlb.append("from bd_defdoclist ");
		 sqlb.append("where code='OCRTHNC' and nvl(dr,0)=0) ");
		 sqlb.append("and ");
		 sqlb.append("pk_defdoc", arraydef20);
		 ArrayList<String> objts = (ArrayList<String>) iuap.executeQuery(sqlb.toString(), new ColumnListProcessor("code"));
		 if(null != objts && objts.size()>0){
			 arrayvos = objts;
		}
		
		 return arrayvos;
		
	}
	/**
	 * ѯ÷Ʊʹü˰ϼ,˰˰
	 * @param code Ʊ
	 * @return
	 * @throws Exception
	 */
	private Map<Object,Object> QryNorigtaxmny(String code) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" SUM( po_invoice_b.norigtaxmny ) as norigtaxmny,");
		sql.append(" SUM( po_invoice_b.norigmny ) as norigmny,");
		sql.append(" SUM( po_invoice_b.ntax ) as ntax");
		sql.append(" FROM");
		sql.append(" po_invoice po_invoice");
		sql.append(" LEFT JOIN po_invoice_b po_invoice_b ON po_invoice.pk_invoice = po_invoice_b.pk_invoice ");
		sql.append(" WHERE");
		sql.append(" po_invoice.fbillstatus <> '0' ");
		sql.append(" AND po_invoice.fbillstatus <> '1' ");
		sql.append(" AND po_invoice_b.vbdef20 IN ( SELECT pk_defdoc FROM bd_defdoc WHERE code LIKE '"+code+"%' )");
		sql.append(" AND nvl(po_invoice.dr,0) = 0");
		sql.append(" AND nvl(po_invoice_b.dr,0) = 0");
		return (Map<Object, Object>) iuap.executeQuery(sql.toString(), new MapProcessor());
	}
}

